import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot)
import java.util.*;
import javax.swing.JOptionPane;

/**
 * @author Miftah Reza 
 * @version 1.1
 */
public class Farm  extends World
{
    // Inisiasi variable untuk method2 yang ada dibawah
    public int shot = 1;
    public int invaders = 50;
    
    Counter score = new Counter("Score: ");
    Counter lives = new Counter("Health: ");
    
    public Farm()
    {    
        // Bikin World ukuran kotak 20x20 dan kotaknya masing-masing berukuran 10x10 pixel beserta object Aktor pada masing-masing kelas
        super(100, 100, 5); 
        addObject(new Hunter(), 50, 90);
        addObject(new Wall(), 75, 70);
        addObject(new Wall(), 50, 70);
        addObject(new Wall(), 25, 70);
        addObject(score, 15, 90);
        addObject(lives, 95, 90);
        lives.add(5);
        populate();
    }
    
    public void ShootSet(int arg)
    {
        //Menyetarakan bahwa variable shot (int) sama dengan arg (int)
        shot = arg;
    }
    
    public boolean CanShoot()
    {
        //Angka 1 artinya bisa nembak, lain dari itu jadi gabisa nembak
        if (shot == 1) {
            return true;
        } else {
            return false;
        }
    }
    
    public void addPoints(int pts)
    {
        //Method untuk menambahkan points atau score
        score.add(pts);
    }
    
    public void die()
    {
        //Method yang berisi nyawa (life) si pemburu
        lives.subtract(1);
        if (lives.getValue() == 0) { //Jika nilai nyawanya = 0 maka si pemburu mati
            gameOver();
            String credit = " - Miftah Reza - 5213100171 "
             +        "\n - M. Yusuf Habibi - 5213100039 "
             +        "\n - Sasongko Kurniawan - 5213100019 "
             +        "\n - Hisyam Naufal Gandhi - 5213100114 ";
        JOptionPane.showMessageDialog(null, credit, "Credit by", 1);
        }
         
        //Menambahkan object pemburu yang bisa menembak
        addObject(new Hunter(), 50, 90);
        shot = 1;
    }
    
    public void gameOver() 
    {
        //Method yang berisi kondisi jika game berakhir (Game Over)
        addObject(new ScoreBoard(score.getValue()), getWidth()/2, getHeight()/2);
        Greenfoot.stop();
    }
    
    public void populate()
    {
        //Jumlah musuh dibaris pertama
        Pig[] enemies1 = new Pig[10];
        for ( int i = 0; i <10; i++ ) {
            enemies1[i] = new Pig();
            addObject(enemies1[i], (i*5)+5, 10);
        }
        
        //Jumlah musuh dibaris kedua
       Chicken[] enemies2 = new Chicken[21];
        for ( int i = 0; i <10; i++ ) {
            enemies2[i] = new Chicken();
            addObject(enemies2[i], (i*5)+5, 15);
        }
        
        //Jumlah musuh dibaris ketiga
        for ( int i = 11; i <21; i++ ) {
            enemies2[i] = new Chicken();
            addObject(enemies2[i], ((i*5)+5)-55, 20);
        } 
        
        //Jumlah musuh dibaris keempat
        Cow[] enemies3 = new Cow[21];
        for ( int i = 0; i <10; i++ ) {
            enemies3[i] = new Cow();
            addObject(enemies3[i], (i*5)+5, 25);
        } 
        
        //Jumlah musuh dibaris kelima
        for ( int i = 11; i <21; i++ ) {
            enemies3[i] = new Cow();
            addObject(enemies3[i], ((i*5)+5)-55, 30);
        } 
    }
}
