import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.util.*; //list, iterator classes
/**
 * @author Miftah Reza   
 * @version 1.1
 */
public class Pig  extends Actor
{
    //Inisiasi variable bebas
    public int dir = 1; //1 = musuh gerak kekiri
                        //2 = musuh gerak kekanan
    
    public int movetimer = 0; //Jeda waktu untuk musuh berpindah tempat
    
    public int shouldMove = 0; //Kondisi dimana si musuh harus pindah
    
    public int shouldCar = 0;
    
    public GreenfootImage img1; //Animasi pergerakan musuh (Gambar 1)
    
    public GreenfootImage img2; //Animasi pergerakan musuh (Gambar 2)
    
    public int shoot; //Variable untuk menentukan tingkat kemungkinan musuh menembak
    
    public int chance = 1; //Kemungkinan musuh untuk menembak adalah 1
    
    public Pig()
    {
        img1 = getImage(); //Icon gambar di kelas ini
        img2 = new GreenfootImage("babi 2.png"); //Gambar kedua untuk pergerakan animasi musuh
    }
    
    public void act() //Looping musuhnya bolak balik
    {
       //Penjelasan ini sama kaya di class Pemburu
       List bullets = getNeighbours(3, false, Bullet.class);
       if (!bullets.isEmpty()) { 
       Actor b = (Actor) bullets.get(0);
       if (b instanceof Bullet) {
           ((Farm) getWorld()).ShootSet(1); //Memungkinkan pemburu untuk menembakan peluru selanjutnya
           getWorld().removeObject(b);
           destroy();
       }
       } else {
           shoot();
           move();    //Jika pemburu masih hidup bisa melakukan kondisi ini
       }
    }
    
    public void destroy()
    {
        Greenfoot.playSound("pig2.wav"); //Suara babi ketika musuh tertembak
        ((Farm) getWorld()).addPoints(10); //Menambahkan points sejumlah 10
        ((Farm) getWorld()).invaders--;
        if (((Farm)getWorld()).invaders <= 0) { //Kalo abis bakal nambah 1 baris lagi
            ((Farm) getWorld()).populate();
            ((Farm)getWorld()).invaders = 50; //Total perbaris kan 10 jadi 50 hewan
        }
        getWorld().removeObject(this); //Remove object musuh setelah tertembak
    }
    
    public void shoot()
    {
        if (shouldMove == 1) {
            shoot = Greenfoot.getRandomNumber(100);
            if (shoot <= chance) {
                getWorld().addObject(new Shit(), getX(), getY()+5);
            }
        }
    }
        
        
    
    public void move() //Method move object yang ada di World
    {
        if (dir == 1 && shouldCar == 1) {
            if (getX() + 5 >= getWorld().getWidth()) { //Jika udah mentok ke pinggir Wolrd
                carridgeRight(); //Memanggil fungsi carride
                carridgeAlliesRight();
                movetimer = 0; //Reset timer
                shouldMove = 0; //Kondisi dimana tidak bisa bergerak
            }
        } else if (dir == 2 && shouldCar == 1) {
            if (getX() - 5 <= 0) {
                carridgeLeft();
                carridgeAlliesLeft();
                movetimer = 0;
                shouldMove = 0;
            }
        }
        if (dir == 1 && shouldMove == 1) { //Jika pergerakannya ke kiri
            if (getImage() == img1) { //Animasi pergerakan musuh
                setImage(img2); 
            } else {
                setImage(img1);
            }
            setLocation(getX()+5, getY()); //Pergerakan
            shouldMove = 0; //Artinya tidak bisa bergerak lagi
        } else if (dir == 2 && shouldMove == 1) { //Pada pada kaya di atas
            if (getImage() == img1) {
                setImage(img2);
            } else {
                setImage(img1);
            }
            setLocation(getX()-5, getY());
            shouldMove = 0;
        } else if (shouldMove == 0) { //Jika kita tidak bisa bergerak
            movetimer++; //Tambah pergerakan
            if (movetimer == 24) {//Jumlah pergerakan adalah 24 step
                shouldCar = 1; //check carride
            } else if (movetimer == 25) {
                shouldMove = 1; //Bisa bergerak lagi
                shouldCar = 0;
                movetimer = 0;
            }
        }
    }
    
    private void carridgeRight() //Perpindahan dan pertukaran tempat
    {
        setLocation(getX(), getY() + 5); //Gerak kebawah
        dir = 2;//Ganti arah
        chance = chance+1; //Nambahin tingkat kemungkinan nembak si pemburu
        if (getY() > 60) {
            ((Farm) getWorld()).gameOver();
        }
    }
    
    private void carridgeLeft()//Sama kaya diatas
    {
        setLocation(getX(), getY() + 5);
        dir = 1;
        chance = chance+1;
    }
    
    private void carridgeAlliesRight()//Pergerakan musuh dan ally nya
    {
        List allies = getWorld().getObjects(Pig.class);//Daftar musuh yang ada di World
        Iterator i = allies.iterator();//Mmebuat iterator agar bisa terjadi perulangan
        while(i.hasNext()) {//Jika ada musuh yang bergerak
            Pig a = (Pig) i.next();//Masukan musuh dalam variable ini
            if ( a != this) {//Jika mereka bukan kita (karna kita udah bergerak)
                a.carridgeRight();//Gerak kebawah
                a.setLocation(a.getX(), a.getY());
                a.shouldMove = 0;
                a.movetimer = 0;
                if (getImage() != a.getImage()) {
                    setImage(a.getImage());
                }
            }
        }
    }
    
    private void carridgeAlliesLeft()//Sama kaya diatas
    {
        List allies = getWorld().getObjects(Pig.class);
        Iterator i = allies.iterator();
        while(i.hasNext()) {
            Pig a = (Pig) i.next();
            if ( a != this) {
                a.carridgeLeft();
                a.setLocation(a.getX(), a.getY());
                a.shouldMove = 0;
                a.movetimer = 0;
                if (getImage() != a.getImage()) {
                    setImage(a.getImage());
                }
            }
        }
    }
}
