import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * @author Miftah Reza
 * @version 1.1
 */
public class ScoreBoard extends Actor
{
    //Inisiasi variable bebas
    public static final float FONT_SIZE = 48.0f;
    public static final int WIDTH = 400;
    public static final int HEIGHT = 300;
   
    public ScoreBoard()
    {
        this(100); //Bebas
    }

    public ScoreBoard(int score)
    {
        //Menampilkan gambar Game Over beserta Score yang di dapat
        makeImage("Kalah bosh", "Scorenya: ", score);
    }

    private void makeImage(String title, String prefix, int score)
    {
        //Method berisi spesifik font, ukuran dan warna dari Gambar diatas
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(0, 0, 0, 160));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(255, 255, 255, 100));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString(title, 60, 100);
        image.drawString(prefix + score, 60, 200);
        setImage(image);
    }
}